import { Bound } from "@canvas-js/okra";
import { AbstractGossipLog, GossipLogInit, ReadOnlyTransaction, ReadWriteTransaction } from "../AbstractGossipLog.js";
export declare class GossipLog<Payload, Result> extends AbstractGossipLog<Payload, Result> {
    private readonly env;
    static open<Payload, Result>(init: GossipLogInit<Payload, Result>, path: string): Promise<GossipLog<Payload, Result>>;
    private static getReadOnlyAPI;
    private static getReadWriteAPI;
    private constructor();
    close(): Promise<void>;
    entries(lowerBound?: Bound<Uint8Array> | null, upperBound?: Bound<Uint8Array> | null, options?: {
        reverse?: boolean;
    }): AsyncIterable<[key: Uint8Array, value: Uint8Array]>;
    read<T>(callback: (txn: ReadOnlyTransaction) => Promise<T>): Promise<T>;
    write<T>(callback: (txn: ReadWriteTransaction) => Promise<T>): Promise<T>;
}
